#include <cstdio>

typedef long long Long;

Long seek_sqrt(Long val) {
	Long l = 0, r = val + 1;
	while (l + 1 < r) {
		Long m = l + (r - l) / 2;
		if (m * m < val) {
			l = m;
		} else {
			r = m;
		}
	}

	return l;
}

Long seek_qbrt(Long val) {
	Long l = 0, r = val + 1;
	while (l + 1 < r) {
		Long m = l + (r - l) / 2;
		if (m * m * m < val) {
			l = m;
		} else {
			r = m;
		}
	}

	return l + 1;
}

int main() {
	Long a, b, k;
	scanf("%ld%ld%ld", &a, &b, &k);
	Long x_min_abs = seek_sqrt(a);
	Long x_max_abs = seek_sqrt(b);
	Long y_min_abs = seek_qbrt(a);
	Long y_max_abs = seek_qbrt(b);

	Long result = 0;
	Long y_min_iter = y_min_abs, y_max_iter = y_min_abs;
	for (Long x_iter = x_min_abs; x_iter <= x_max_abs; x_iter++) {
		while (y_min_iter < y_max_abs && y_min_iter * y_min_iter * y_min_iter + k < x_iter * x_iter) {
			y_min_iter++;
		}

		while (y_max_iter < y_max_abs && y_max_iter * y_max_iter * y_max_iter < x_iter * x_iter + k) {
			y_max_iter++;
		}
		
		/* printf("%ld %ld %ld %ld ; %ld >= %ld >= %ld\n", y_min_iter, x_iter, y_max_iter, k,
				y_min_iter * y_min_iter * y_min_iter + k,
				x_iter * x_iter,
				y_max_iter * y_max_iter * y_max_iter - k); */

		if (y_max_iter > y_min_iter) {
			result += y_max_iter - y_min_iter;
		}
	}

	printf("%ld\n", result);
}

