#include <cstdio>
#include <algorithm>

typedef long long Long;

Long square(Long val) {
	return val * val;
}

Long cube(Long val) {
	return val * val * val;
}

Long seek_sqrt(Long val) {
	Long l = 0, r = val + 1;
	while (l + 1 < r) {
		Long m = l + (r - l) / 2;
		if (square(m) < val) {
			l = m;
		} else {
			r = m;
		}
	}

	return l + 1;
}

Long seek_cbrt(Long val) {
	Long l = 0, r = val + 1;
	while (l + 1 < r) {
		Long m = l + (r - l) / 2;
		if (cube(m) < val) {
			l = m;
		} else {
			r = m;
		}
	}

	return l + 1;
}

int main() {
	Long a, b, k;
	scanf("%ld%ld%ld", &a, &b, &k);
	Long x_begin = seek_sqrt(a);
	Long y_begin = seek_cbrt(a);

	Long result = 0;
	Long y_min = y_begin, y_max = y_begin;
	for (Long x = x_begin; square(x) <= b; x++) {
		while (cube(y_min + 1) <= b && cube(y_min) + k < square(x)) {
			y_min++;
		}

		while (cube(y_max + 1) <= b && cube(y_max + 1) <= square(x) + k) {
			y_max++;
		}

		if (y_min <= y_max && cube(y_max) + k >= square(x) && cube(y_min) <= square(x) + k) {
			result += y_max - y_min + 1;
		}
	}

	printf("%ld\n", result);
}

