#include <iostream>
#include <algorithm>
#include <string>

using namespace std;

struct Spec {
	string spec;
	int id;
	int price;
};

struct Program {
	Spec *spec;
	int pos;
};

struct Node {
	basic_string<Program *> programs;
	int id;
	int prev;
	char type;
};

Node *nodes;
Spec *specs;
basic_string<Spec *> alphabet[26];

bool comparator(const Spec *a, const Spec *b) {
	return a->price < b->price;
}

int main() {
	int n, m, t;
	cin >> n >> m >> t;
	n--;

	nodes = new Node[n];
	for (int i = 0; i < n; i++) {
		// cerr << "Node #" << i << endl;
		nodes[i].id = i;
		cin >> nodes[i].prev;
		nodes[i].prev -= 2;
		cin >> nodes[i].type;
	}

	specs = new Spec[m];
	int max_len = 0;

	for (int i = 0; i < m; i++) {
		// cerr << "Spec #" << i << endl;
		specs[i].id = i;
		cin >> specs[i].price;
		string str;
		cin >> str;
		specs[i].spec = str;
		alphabet[str[str.size() - 1] - 'a'].push_back(&specs[i]);
		
		if (str.size() > max_len) {
			max_len = str.size();
		}
	}

	for (int i = 0; i < 26; i++) {
		if (!alphabet[i].empty()) {
			sort(alphabet[i].begin(), alphabet[i].end(), comparator);
		}
	}
	// cerr << "Alphabet sorted" << endl;

	int result = 0;
	if (max_len == 1) {
		for (int i = 0; i < n; i++) {
			result += alphabet[nodes[i].type - 'a'][0]->price;
		}
		printf("%d\n", result);
	}

	delete[] nodes;
	delete[] specs;
}

